    Program f04affe

!     F04AFF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: f03aef, f04aff, nag_wp, x02ajf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Real (Kind=nag_wp)               :: d1, eps
      Integer                          :: i, id, ifail, ir, k, lda, ldb, ldbb, &
                                          ldx, n
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: a(:,:), b(:,:), bb(:,:), p(:), x(:,:)
!     .. Executable Statements ..
      Write (nout,*) 'F04AFF Example Program Results'
      Write (nout,*)
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n
      ir = 1
      lda = n
      ldb = n
      ldbb = n
      ldx = n
      Allocate (a(lda,n),b(ldb,ir),bb(ldbb,ir),p(n),x(ldx,ir))
      Read (nin,*)(a(i,1:n),i=1,n)

!     ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
      ifail = 0
!     Cholesky decomposition
      Call f03aef(n,a,lda,p,d1,id,ifail)

      Read (nin,*)(b(i,1:ir),i=1,n)
      eps = x02ajf()

      ifail = 0
!     Accurate solution of linear equations
      Call f04aff(n,ir,a,lda,p,b,ldb,eps,x,ldx,bb,ldbb,k,ifail)

      Write (nout,*) ' Solution'
      Do i = 1, n
        Write (nout,99999) x(i,1:ir)
      End Do

99999 Format (1X,8F9.4)
    End Program f04affe
